"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/** @module stately-react */
var React = require("react");
function createControllableContext(reducer, middleware) {
    var _a = React.createContext(null), Provider = _a.Provider, Consumer = _a.Consumer;
    var Controller = /** @class */ (function (_super) {
        __extends(Controller, _super);
        function Controller() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Controller.prototype.render = function () {
            return React.createElement(Provider, { value: this.props }, this.props.children);
        };
        return Controller;
    }(React.Component));
    var Controllable = /** @class */ (function (_super) {
        __extends(Controllable, _super);
        function Controllable(props) {
            var _this = _super.call(this, props) || this;
            _this.dispatch = function (action) {
                _this.setState(reducer(_this.state, action));
                return action;
            };
            _this.state = reducer(undefined, { type: '@@CONTROLLABLE' });
            if (middleware) {
                _this.dispatch = middleware({
                    dispatch: _this.dispatch,
                    getState: function () { return _this.state; },
                })(_this.dispatch);
            }
            return _this;
        }
        Controllable.prototype.render = function () {
            var _this = this;
            return (React.createElement(Consumer, null, function (controller) {
                return controller
                    ? _this.props.children(controller.state, controller.dispatch)
                    : _this.props.children(_this.state, _this.dispatch);
            }));
        };
        return Controllable;
    }(React.Component));
    return {
        Controller: Controller,
        Controllable: Controllable,
    };
}
exports.createControllableContext = createControllableContext;
//# sourceMappingURL=Controllable.js.map