/** @module stately-react */
import * as React from 'react';
import { Action } from 'redux';
import { SubjectLike, StoreLike } from 'stately-async/observables';
import { Subtract } from 'stately-async/subtraction';
declare type SubscriberChildren<S, A> = (state: S, next: (next: A) => void) => React.ReactNode;
export interface SubscriberProps<S, A = S> {
    children: SubscriberChildren<S, A>;
}
export interface SubscriptionProps<S, A = S> {
    children: SubscriberChildren<S, A> | React.ReactNode;
}
export declare type Subscription<S, A = S> = React.ComponentType<SubscriptionProps<S, A>>;
export declare type Subscriber<S, A = S> = React.ComponentType<SubscriberProps<S, A>>;
export declare type SubscriberDecorator<S, A = S> = <D>(deriveProps: (state: S, next: (next: A) => void) => D) => <P>(Component: React.ComponentType<P extends D ? P : D>) => React.ComponentClass<Subtract<P, D>>;
export interface SubscriptionContext<S, A> {
    Subscription: Subscription<S, A>;
    Subscriber: Subscriber<S, A>;
    subscriber: SubscriberDecorator<S, A>;
}
export declare const createStoreContext: <S, A extends Action<any>>(store: StoreLike<S, A>) => SubscriptionContext<S, A>;
export declare function createSubjectContext<S, A = S>(subject: SubjectLike<S, A>, initial: S): SubscriptionContext<S, A>;
export {};
